#!/usr/bin/perl

######################################################
#
# Copyright  2002 DzM (dzm@dzm.com)
# The Univers Black bitmap is copyright and owned by Adobe Systems.
# I really hope they don't mind my adapting it for this use.
#
########
# No warranties made or implied. This will probably vandalize your
# belongings if you use it.
########
#
# The intent of this script is to pick up an image, slap a time stamp
# and assorted text on it, and save the image somewhere.
#
# I'm using it for a webcam scenareo. I use cron to run it every sixty
# seconds.
#
# Information about ppmcaption can be found at:
#   http://www.jwz.org/ppmcaption/
#
# v. 0.01 - June 8, 2002
#    0.02 - Aug 12, 2002
#           General cleanup, breaking the comman line into more
#           variable driven format, allow specification of a vacation
#           message
#
######################################################

# Where we get the tools from - calling them indirectly breaks if
# $PATH is munged
 $djpeg = "/usr/bin/djpeg";
 $cjpeg = "/usr/bin/cjpeg";
 $ppmcaption = "/usr/local/bin/ppmcaption";


#####
# From here we control what gets printed and what it looks like.
# You should check paths, etc.
#####

# Stuff that controls extra messages
 $vac = 0;
 $big_vac_msg = "\"On Vacation Until July 15, 2002\"";
 $big_vac_pos = "10,20";
 $sml_vac_msg = "\"VACATION!\"";
 $sml_vac_pos = "-3,10";
 #vacation variation
 $vc_bg_col = "red";

# Stuff that controls where we get our image from and where it goes
 $image = "/home/ftpoozer/officeBig.jpg";
 $image_stamp = (stat($image))[9];
 $out_dir = "/home/httpd/work_dir";

# Stuff that controls how it looks
 $font = "/home/httpd/cgi-bin/stamp_img/48.Univers-Black.bdf";
 $blur = "5";
 $sml_scale = ".2";
 $big_scale = ".35";
 $fg_col = "black";
 $bg_col = "white";
 $txt_date = "\"%a, %m/%d/%Y, %T\"";
 $txt_vanity = "\"www.DzM.com\"";


# No user servicable parts in here. Read no further. Doing so may start fires.
# ----------------------------------------------------------------------------


# $stamp will have a future use. For now it serves no real value. Same
# for $work.
 $stamp = "";
 $temp = "work";

# Build the command line options for ppmcation
  $big_ppm_opts = "" .
       " -font $font -scale $big_scale -right -blur $blur -fg $fg_col -bg $bg_col -pos -10,-10" .
         " -text $txt_date" .
       " -font $font -scale $big_scale -blur -left $blur -fg $fg_col -bg $bg_col -pos 10,-10" .
         " -text $txt_vanity";
  $sml_ppm_opts = "" .
       " -font $font -scale $sml_scale -right -blur $blur -fg $fg_col -bg $bg_col -pos -5,-5" .
         " -text $txt_date" .
       " -font $font -scale $sml_scale -left -blur $blur -fg $fg_col -bg $bg_col -pos 3,10" .
         " -text $txt_vanity";

  # Print a vacation message if so desired
  if ($vac != 0) {
    $big_ppm_opts = $big_ppm_opts .
      " -font $font -scale $big_scale -left -blur $blur -fg $fg_col -bg $vc_bg_col -pos $big_vac_pos" .
	" -text $big_vac_msg";
    $sml_ppm_opts = $sml_ppm_opts .
      " -font $font -scale $sml_scale -right -blur $blur -fg $fg_col -bg $vc_bg_col -pos $sml_vac_pos" .
	" -text $sml_vac_msg";
  }


# Perform magic.
# djpeg unpacks the JPEG and pipes it to ppmcaption. ppmcation adds a
# time stamp and passes the result to cjpeg. cjpeg repacks the JPEG
# and saves it to our work directory.
     # Make the big file
     system("$djpeg $image | $ppmcaption " .
       " $big_ppm_opts " .
       " | $cjpeg > $out_dir/B$temp.jpg");

     # When problems happen the images end up being zero bytes in size.
     # We're checking the file size before moving it into place.
     $new_size = (stat("$out_dir/B$temp.jpg"))[7];
     if ($new_size > 0) {
       system("rm -rf $out_dir/latestB.jpg ;" .
        "mv $out_dir/B$temp.jpg $out_dir/B$stamp.jpg ;" .
        "ln -s $out_dir/B$stamp.jpg $out_dir/latestB.jpg");
     }

     # Make the small file
     system("$djpeg -scale 1/4 $image | $ppmcaption " .
	    " $sml_ppm_opts " .
	    " | $cjpeg > $out_dir/S$temp.jpg");

     $new_size = (stat("$out_dir/S$temp.jpg"))[7];
     if ($new_size > 0) { 
       system("rm -rf $out_dir/latestS.jpg ;" .
        "mv $out_dir/S$temp.jpg $out_dir/S$stamp.jpg ;" .
        "ln -s $out_dir/S$stamp.jpg $out_dir/latestS.jpg");
     }

# All Done!
exit;
